VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.IBasePlugin
Const PixelFormatBPPMask As Long = &HFF00&
Dim m_sName As String
Dim token As Long ' Needed to close GDI+
Dim oserver As core.CServer
Dim GDI As Boolean
Private Function IBasePlugin_StartPlugin(Name As String) As Long
    
    Dim GpInput As GdiplusStartupInput
    
    If App.PrevInstance Then
       Exit Function
    End If
    
    Dim textline As String
    Dim doneFirst As Boolean
    
    m_sName = Name
    
    Set oserver = CreateObject("core.CServer")
    oserver.RegisterBang Name, "!update"
    
    GDI = True
    GpInput.GdiplusVersion = 1
    If GdiplusStartup(token, GpInput) <> Ok Then
        oserver.Execute "!log core.update Error loading GDI+!, will not be able to update screenshot"
        GDI = False
    End If
    
    IBasePlugin_StartPlugin = 0
    
End Function
Private Sub IBasePlugin_StopPlugin()

    If GDI Then
        Call GdiplusShutdown(token)
    End If

End Sub
Private Sub IBasePlugin_Bang(ByVal Name As String, ByVal Arguments As String)

    Select Case Name
    Case "!update"
        Select Case LCase(Arguments)
        Case "modules"
            update "modules"
        Case "system"
            update "system"
        Case "screenshot"
            update "screenshot"
        Case "plugins"
            update "plugins"
        Case ""
            update ""
        Case Else
            update Arguments
        End Select
    End Select
   
End Sub
Private Function getCPU() As String

    Dim SI As SYSTEM_INFO
    Dim tmp As String
    Dim Temp As String
    
    Call GetSystemInfo(SI)
    
    Temp = SI.dwNumberOfProcessors & " "
    
    Select Case SI.wProcessorLevel
       Case PROCESSOR_LEVEL_80386: tmp = "Intel 80386"
       Case PROCESSOR_LEVEL_80486: tmp = "Intel 80486"
       Case PROCESSOR_LEVEL_PENTIUM: tmp = "Intel Pentium"
       Case PROCESSOR_LEVEL_PENTIUMII: tmp = "Intel Pentium Pro or better"
    End Select
    
    getCPU = Temp & tmp & " at " & GetCPUSpeed() & " MHz"
   
End Function
Private Sub update(what As String)
        
    Dim sRet As String
    Dim I As Long
    Dim j As Long
    Dim h As Long
    Dim tUser As String
    Dim tPass As String
    Dim tStr As String
    Dim sections() As String
    Dim mods() As core.IBasePlugin
    Dim done() As String
    Dim found As Boolean
    Dim ret As String
    Dim url As String
    Dim lp() As IBasePlugin
    Dim lp2() As IBasePlugin
    Dim lpnames() As String
    Dim response As String
    Dim curPlugin As String
    Dim img As Long
    Dim encoderCLSID As CLSID
    Dim stat As GpStatus
    Dim strImage As String
    Dim strBody As String
    Dim aPostData() As Byte
    Dim nFile As Integer
    Dim filetype As String
    Dim encoderParams As EncoderParameters
    Dim lngQuality As Long
    Dim hFile As Long
    Dim modulepath As String
    
    ReDim lpnames(0)
    
    oserver.Execute "!log core.update starting"
    url = oserver.GetKey(m_sName, "mainurl")
    If url = "" Then url = "http://www.coreshell.info"
    
    If what = "system" Or what = "modules" Or what = "screenshot" Or what = "" Then
    
        tUser = oserver.GetKey(m_sName, "user")
        If tUser = "" Then
            oserver.Execute "!log Couldn't find username, requesting"
            tUser = InputBox("Please enter your username:", "Username", "")
        End If
        tPass = oserver.GetKey(m_sName, "pass")
        If tPass = "" Then
            oserver.Execute "!log Couldn't find password, requesting"
            tPass = InputBox("Please enter your password:", "Password", "")
        End If
        If getURL(url & "/users.php3?" & "action=verify&user=" & tUser & "&pass=" & tPass) <> "ok" Then
            oserver.Execute "!Log Error: You dont have an account on the core website or the username/password that you have supplied are wrong. Please register or check you settings before running the program again."
            If what = "" Then what = "modules" Else Exit Sub
        End If
    End If
        
    If (oserver.evalBool(oserver.GetKey(m_sName, "modules")) And what = "") Or what = "modules" Then
        
        oserver.Execute "!log core.update updating loaded modules"
        ReDim done(0)
        
        ret = getURL(url & "/users.php3?" & "action=clearmods&user=" & tUser & "&pass=" & tPass)
        If ret <> "ok" Then
            oserver.Execute "!Log Error: Failed to clear the  module settings"
        End If
        
        mods = oserver.LoadedPlugins
        For I = 1 To UBound(mods)
            found = False
            For j = 1 To UBound(done)
                If mods(I).PluginName = done(j) Then
                    found = True
                    Exit For
                End If
            Next j
            If Not found Then
                ReDim Preserve done(UBound(done) + 1)
                done(UBound(done)) = mods(I).PluginName
                tStr = "&name=" & Replace(mods(I).PluginName, " ", "%20")
                tStr = tStr & "&version=" & Replace(mods(I).Version, " ", "%20")
                ret = getURL(url & "/users.php3?" & "action=addmod&user=" & tUser & "&pass=" & tPass & tStr)
                If ret <> "ok" Then
                    oserver.Execute "!Log Error: Failed to update system settings (" & ret & ")"
                End If
            End If
            DoEvents
        Next I
    End If
    
    If (oserver.evalBool(oserver.GetKey(m_sName, "system")) And what = "") Or what = "system" Then
        oserver.Execute "!log core.update updating system setup"
        tStr = "&cpu=" & getCPU & "&os=" & GetOS & "&core=" & oserver.Version
        tStr = Replace(tStr, " ", "%20")
        ret = getURL(url & "/users.php3?" & "action=addsys&user=" & tUser & "&pass=" & tPass & tStr)
        If ret <> "ok" Then
            oserver.Execute "!Log Error: Failed to update system settings (" & ret & ")"
        End If
        DoEvents
    End If
    
    
    If ((oserver.evalBool(oserver.GetKey(m_sName, "screenshot")) And what = "") Or what = "screenshot") And GDI Then
        oserver.Execute "!log core.update capturing screenshot"
        
        filetype = oserver.GetKey(m_sName, "filetype")
        If filetype = "" Then filetype = "jpg"
        
        CaptureScreen App.path & "\users.bmp"
        
        oserver.Execute "!log core.update processing screenshot"
        
        Call GdipLoadImageFromFile(StrConv(App.path & "\users.bmp", vbUnicode), img)
        Select Case LCase(filetype)
        Case "png"
            ' Get the CLSID of the PNG encoder
            Call GetEncoderClsid("image/png", encoderCLSID)
    
            ' Save as a PNG file. There are no encoder parameters for PNG images, so we pass a NULL.
            ' NOTE: The NULL (aka 0) must be passed byval, as the function declaration would get a pointer to the number 0.
            stat = GdipSaveImageToFile(img, StrConv(App.path & "\users.png", vbUnicode), encoderCLSID, ByVal 0)
        Case "gif"
           ' Get the CLSID of the GIF encoder
           Call GetEncoderClsid("image/gif", encoderCLSID)
           ' Now save the bitmap as a gif
           ' NOTE: The image will be saved using the Halftone palette, unless the image has its own palette,
           '       except under some circumstances. See Q318343 and Q315780 for more info.
           stat = GdipSaveImageToFile(img, StrConv(App.path & "\users.gif", vbUnicode), encoderCLSID, ByVal 0)
        Case "jpg"

            ' Get the CLSID of the JPEG encoder
            Call GetEncoderClsid("image/jpeg", encoderCLSID)

            ' Save as a JPEG file. This format requires encoder parameters.
            lngQuality = oserver.evalNum(oserver.GetKey(m_sName, "JPGQuality"))
            If lngQuality = 0 Then lngQuality = 90
            ' Setup the encoder paramters
            encoderParams.count = 1    ' Only one element in this Parameter array
            With encoderParams.Parameter
                .NumberOfValues = 1     ' Should be one
                .type = EncoderParameterValueTypeLong
                ' Set the GUID to EncoderQuality
                .GUID = DEFINE_GUID(EncoderQuality)
                .value = VarPtr(lngQuality)  ' Remember: The value expects only pointers!
            End With
   
            ' Now save the bitmap as a jpeg at 10% compression
            stat = GdipSaveImageToFile(img, StrConv(App.path & "\users.jpg", vbUnicode), encoderCLSID, encoderParams)

        Case Else
            oserver.Execute "!log core.update unknown filetype, aborting"
            stat = Aborted
        End Select
        
        If stat <> Ok Then
            oserver.Execute "!log core.update error saving file! Status Code: " & stat
        Else
            oserver.Execute "!log core.update uploading screenshot"
            
            Dim oHttp As XMLHTTPRequest

            'make use of the XMLHTTPRequest object contained in msxml.dll
            Set oHttp = New XMLHTTPRequest
            
            'read the JPEG file
            nFile = FreeFile
            Open App.path & "\users." & filetype For Binary As #nFile
            strImage = String(LOF(nFile), " ")
            Get #nFile, , strImage
            Close #nFile
            
            'fire of an http request
            oHttp.open "POST", url & "/upload.php3", False
            oHttp.setRequestHeader "Content-Type", "multipart/form-data, boundary=AaB03x"
            'assemble the body. send one field and one file

           strBody = _
               "--AaB03x" & vbCrLf & _
               "Content-Disposition: form-data; name=""user""" & vbCrLf & vbCrLf & tUser & vbCrLf & _
               "--AaB03x" & vbCrLf & _
               "Content-Disposition: form-data; name=""pass""" & vbCrLf & vbCrLf & tPass & vbCrLf & _
               "--AaB03x" & vbCrLf & _
                "Content-Disposition: form-data; name=""userfile""; filename=""" & App.path & "\users." & LCase(filetype) & """" & vbCrLf & _
               "Content-Transfer-Encoding: binary" & vbCrLf
               Select Case LCase(filetype)
               Case "jpg"
                    strBody = strBody & "Content-Type: image/pjpeg" & vbCrLf
               Case "png"
                    strBody = strBody & "Content-Type: image/png" & vbCrLf
               Case "gif"
                    strBody = strBody & "Content-Type: image/gif" & vbCrLf
               End Select
               strBody = strBody & vbCrLf & _
                    strImage & vbCrLf & _
                    "--AaB03x--"

            
            'must convert to byte array because of binary zeros
            aPostData = StrConv(strBody, vbFromUnicode)
            'send it
            oHttp.send aPostData
            'check the feedback
            oserver.Execute "!log core.update " & oHttp.responseText
        End If
        DoEvents
        On Error GoTo skip
        Kill App.path & "\users.bmp"
        Kill App.path & "\users." & filetype
skip:
        On Error GoTo 0
        DoEvents
        
        ' Cleanup
        Call GdipDisposeImage(img)
    
    End If
    
    If (oserver.evalBool(oserver.GetKey(m_sName, "plugins")) And what = "") Or (what <> "modules" And what <> "system" And what <> "screenshot") Then
    
        If (oserver.evalBool(oserver.GetKey(m_sName, "plugins")) And what = "") Or what = "plugins" Then
            what = ""
        End If
        
        url = oserver.GetKey(m_sName, "pluginurl")
        If url = "" Then url = "http://modules.coreshell.info"
        oserver.Execute "!log Checking for plugin updates on " & url
        
        lp = oserver.LoadedPlugins
        
        For I = 1 To UBound(lp)
            If I > UBound(lp) Then Exit For
            For j = I + 1 To UBound(lp)
                If j > UBound(lp) Then Exit For
                If lp(I).PluginName = lp(j).PluginName Then
                    Debug.Print "removed one"
                    For h = j To UBound(lp) - 1
                        Set lp(h) = lp(h + 1)
                    Next h
                    j = j - 1
                    ReDim Preserve lp(UBound(lp) - 1)
                End If
            Next j
        Next I
        
        For I = 1 To UBound(lp)
            Debug.Print lp(I).PluginName
            If InStr(lp(I).PluginName, ".") Then
                curPlugin = LCase(Right(lp(I).PluginName, Len(lp(I).PluginName) - InStr(lp(I).PluginName, ".")))
            Else
                curPlugin = LCase(lp(I).PluginName)
            End If
            If (what <> "" And LCase(what) = curPlugin) Or what = "" Then
                response = getURL(url & "/update.php3?" & "action=version&module=" & curPlugin)
                If LCase(Left(response, 3)) = "ok:" Then
                    response = Right(response, Len(response) - 4)
                    If CDbl(Replace(response, ".", ",")) > CDbl(Replace(lp(I).Version, ".", ",")) Then
                        oserver.Execute "!log core.update found a new version of " & curPlugin & ", upgrading"
                        response = getURL(url & "/update.php3?" & "action=url&module=" & curPlugin)
                        If LCase(Left(response, 3)) = "ok:" Then
                            response = Right(response, Len(response) - 4)
                            Debug.Print response
                            response = getURL(response)
                            If response <> "" Then
                                hFile = FreeFile
                                Open App.path & "\update.tmp" For Binary Access Write As hFile
                                Put hFile, , response
                                Close hFile
                                
                                lp2 = oserver.LoadedPlugins
                                For j = 1 To UBound(lp2)
                                    If lp2(j).PluginName = curPlugin Then
                                        modulepath = oserver.GetKey(lp2(j).InstanceName, "modules")
                                        ReDim Preserve lpnames(UBound(lpnames) + 1)
                                        lpnames(UBound(lpnames)) = lp2(j).InstanceName
                                        oserver.UnloadPlugin lp2(j).InstanceName
                                    End If
                                Next j
                                ret = oserver.RegisterComponent(curPlugin, DllUnRegisterServer)
                                If ret <> 0 Then
                                    oserver.Execute "!log core.update error unregistering " & curPlugin
                                End If
                                
                                ' Start unziping
                                Dim MsgTmp As String
                                
                                '-- Init Global Message Variables
                                uZipInfo = ""
                                uZipNumber = 0   ' Holds The Number Of Zip Files
                                
                                '-- Select UNZIP32.DLL Options - Change As Required!
                                uPromptOverWrite = 1  ' 1 = Prompt To Overwrite
                                uOverWriteFiles = 0   ' 1 = Always Overwrite Files
                                uDisplayComment = 0   ' 1 = Display comment ONLY!!!
                                
                                '-- Change The Next Line To Do The Actual Unzip!
                                uExtractList = 1       ' 1 = List Contents Of Zip 0 = Extract
                                uHonorDirectories = 1  ' 1 = Honour Zip Directories
                                
                                '-- Select Filenames If Required
                                '-- Or Just Select All Files
                                uZipNames.uzFiles(0) = vbNullString
                                uNumberFiles = 0
                                
                                '-- Select Filenames To Exclude From Processing
                                ' Note UNIX convention!
                                '   vbxnames.s(0) = "VBSYX/VBSYX.MID"
                                '   vbxnames.s(1) = "VBSYX/VBSYX.SYX"
                                '   numx = 2
                                
                                '-- Or Just Select All Files
                                uExcludeNames.uzFiles(0) = vbNullString
                                uNumberXFiles = 0
                                
                                uZipFileName = App.path & "\update.tmp"
                                uExtractDir = modulepath
                                uExtractList = 0
                                
                                '-- Let's Go And Unzip Them!
                                Call VBUnZip32
                                
                                '-- Tell The User What Happened
'                                If Len(uZipMessage) > 0 Then
'                                    oserver.Execute "!log core.update " & uZipMessage
'                                End If
                                
                                '-- Display Zip File Information.
'                                If Len(uZipInfo) > 0 Then
'                                    oserver.Execute "!log core.update " & uZipInfo
'                                End If
                                
                                Kill App.path & "\update.tmp"
                                
                                ret = oserver.RegisterComponent(curPlugin, DllRegisterServer)
                                
                                For j = 1 To UBound(lpnames)
                                    oserver.LoadPlugin lpnames(j), curPlugin
                                Next j
                                
                            Else
                                oserver.Execute "!log there is a updated version of " & curPlugin & " available, but the download atempt failed"
                            End If
                            
                        Else
                            oserver.Execute "!log there is a updated version of " & curPlugin & " available, but the download atempt failed"
                        End If
                    End If
                Else
                    oserver.Execute "!log " & response & " when trying to update " & curPlugin
                End If
            End If
        Next I
    End If
    
    oserver.Execute "!log core.update done"

End Sub
Public Property Get IBasePlugin_InstanceName() As String

    IBasePlugin_InstanceName = m_sName

End Property
Public Property Get IBasePlugin_PluginName() As String

    IBasePlugin_PluginName = App.Title

End Property
Public Property Get IBasePlugin_Copyright() As String

    IBasePlugin_Copyright = App.LegalCopyright

End Property
Public Property Get IBasePlugin_Version() As String

    IBasePlugin_Version = App.Major & "." & App.Minor

End Property
Public Property Get IBasePlugin_Description() As String

    IBasePlugin_Description = App.FileDescription

End Property
Private Function IsInArray(vData() As IBasePlugin, vSrchData As String, lStart As Long) As Boolean
    
  Dim hi As Long
  hi = UBound(vData)
  Do Until lStart > hi
      If StrComp(vData(lStart).PluginName, vSrchData, 0) = 0 Then
          IsInArray = True
          Exit Function
      End If
      lStart = lStart + 1
  Loop
  IsInArray = False
    
End Function

