Attribute VB_Name = "ModSysInfo"
Option Explicit
Public Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As MEMORYSTATUS)
Public Declare Sub GetSystemInfo Lib "kernel32" (lpSystemInfo As SYSTEM_INFO)
Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

'Flags for GetSystemInfo
Public Const PROCESSOR_INTEL_386 As Long = 386
Public Const PROCESSOR_INTEL_486 As Long = 486
Public Const PROCESSOR_INTEL_PENTIUM As Long = 586
Public Const PROCESSOR_MIPS_R4000 As Long = 4000
Public Const PROCESSOR_ALPHA_21064 As Long = 21064
Public Const PROCESSOR_PPC_601 As Long = 601
Public Const PROCESSOR_PPC_603 As Long = 603
Public Const PROCESSOR_PPC_604 As Long = 604
Public Const PROCESSOR_PPC_620 As Long = 620
Public Const PROCESSOR_HITACHI_SH3 As Long = 10003    'Windows CE
Public Const PROCESSOR_HITACHI_SH3E As Long = 10004   'Windows CE
Public Const PROCESSOR_HITACHI_SH4 As Long = 10005    'Windows CE
Public Const PROCESSOR_MOTOROLA_821 As Long = 821     'Windows CE
Public Const PROCESSOR_SHx_SH3 As Long = 103          'Windows CE
Public Const PROCESSOR_SHx_SH4 As Long = 104          'Windows CE
Public Const PROCESSOR_STRONGARM As Long = 2577       'Windows CE - 0xA11
Public Const PROCESSOR_ARM720 As Long = 1824          'Windows CE - 0x720
Public Const PROCESSOR_ARM820 As Long = 2080          'Windows CE - 0x820
Public Const PROCESSOR_ARM920 As Long = 2336          'Windows CE - 0x920
Public Const PROCESSOR_ARM_7TDMI As Long = 70001      'Windows CE

Public Const PROCESSOR_ARCHITECTURE_INTEL As Long = 0
Public Const PROCESSOR_ARCHITECTURE_MIPS As Long = 1
Public Const PROCESSOR_ARCHITECTURE_ALPHA As Long = 2
Public Const PROCESSOR_ARCHITECTURE_PPC As Long = 3
Public Const PROCESSOR_ARCHITECTURE_SHX As Long = 4
Public Const PROCESSOR_ARCHITECTURE_ARM As Long = 5
Public Const PROCESSOR_ARCHITECTURE_IA64 As Long = 6
Public Const PROCESSOR_ARCHITECTURE_ALPHA64 As Long = 7
Public Const PROCESSOR_ARCHITECTURE_UNKNOWN   As Long = &HFFFF

Public Const PROCESSOR_LEVEL_80386 As Long = 3
Public Const PROCESSOR_LEVEL_80486 As Long = 4
Public Const PROCESSOR_LEVEL_PENTIUM As Long = 5
Public Const PROCESSOR_LEVEL_PENTIUMII As Long = 6

Public Const sCPURegKey = "HARDWARE\DESCRIPTION\System\CentralProcessor\0"

Public Const HKEY_LOCAL_MACHINE As Long = &H80000002

Public Type SYSTEM_INFO
   dwOemID As Long
   dwPageSize As Long
   lpMinimumApplicationAddress As Long
   lpMaximumApplicationAddress As Long
   dwActiveProcessorMask As Long
   dwNumberOfProcessors As Long
   dwProcessorType As Long
   dwAllocationGranularity As Long
   wProcessorLevel As Integer
   wProcessorRevision As Integer
End Type

Public Type MEMORYSTATUS
    dwLength As Long
    dwMemoryLoad As Long
    dwTotalPhys As Long
    dwAvailPhys As Long
    dwTotalPageFile As Long
    dwAvailPageFile As Long
    dwTotalVirtual As Long
    dwAvailVirtual As Long
End Type

Const VER_PLATFORM_WIN32s = 0
Const VER_PLATFORM_WIN32_WINDOWS = 1
Const VER_PLATFORM_WIN32_NT = 2

'windows-defined type OSVERSIONINFO
Public Type OSVERSIONINFO
  OSVSize         As Long         'size, in bytes, of this data structure
  dwVerMajor      As Long         'ie NT 3.51, dwVerMajor = 3; NT 4.0, dwVerMajor = 4.
  dwVerMinor      As Long         'ie NT 3.51, dwVerMinor = 51; NT 4.0, dwVerMinor= 0.
  dwBuildNumber   As Long         'NT: build number of the OS
                                  'Win9x: build number of the OS in low-order word.
                                  '       High-order word contains major & minor ver nos.
  PlatformID      As Long         'Identifies the operating system platform.
  szCSDVersion    As String * 128 'NT: string, such as "Service Pack 3"
                                  'Win9x: 'arbitrary additional information'
End Type

Const nkb As Long = 1024


Public Function GetCPUSpeed() As Long
   
   Dim hKey As Long
   Dim cpuSpeed As Long
    
  'Open CPU key
   Call RegOpenKey(HKEY_LOCAL_MACHINE, sCPURegKey, hKey)
                    
  'and retrieve the value
   Call RegQueryValueEx(hKey, "~MHz", 0, 0, cpuSpeed, 4)
   Call RegCloseKey(hKey)
    
   GetCPUSpeed = cpuSpeed

End Function
Public Function GetOS() As String

   Dim OSV As OSVERSIONINFO
   Dim R As Long
   Dim pos As Integer
   Dim sVer As String
   Dim sBuild As String
   
   OSV.OSVSize = Len(OSV)
   
   If GetVersionEx(OSV) = 1 Then
   
     'PlatformId contains a value representing the OS
      Select Case OSV.PlatformID
         Case VER_PLATFORM_WIN32s: GetOS = "32s"
         Case VER_PLATFORM_WIN32_NT:
                   
           'dwVerMajor = NT version.
           'dwVerMinor = minor version
            Select Case OSV.dwVerMajor
               Case 3:
               
                  Select Case OSV.dwVerMinor
                     Case 0:  GetOS = "Windows NT3"
                     Case 1:  GetOS = "Windows NT3.1"
                     Case 5:  GetOS = "Windows NT3.5"
                     Case 51: GetOS = "Windows NT3.51"
                  End Select
            
               Case 4: GetOS = "Windows NT4"
               Case 5: GetOS = "Windows 2000"
            End Select
         
         Case VER_PLATFORM_WIN32_WINDOWS:
         
           'dwVerMinor bit tells if its 95 or 98.
            Select Case OSV.dwVerMinor
               Case 0:    GetOS = "Windows 95"
               Case Else: GetOS = "Windows 98"
            End Select
         
      End Select
   
   End If

End Function

